/* $Id: gtk-makeimage.cc,v 1.3 2003/04/23 14:53:44 richard Exp $ -*- C++ -*-
  __   _
  |_) /|  Copyright (C) 2003 Richard Atterer
  | \/|  <richard at atterer.net>
   '` 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2. See
  the file COPYING for details.

  Download and processing of .jigdo files - GTK+ frontend

*/

#include <config.h>

#include <iostream>

#include <gtk-makeimage.hh>
#include <gtk-single-url.hh>
//______________________________________________________________________

GtkMakeImage::GtkMakeImage(const string& uriStr, const string& destination)
  : treeViewStatus(), mid(this, uriStr, destination) { }

GtkMakeImage::~GtkMakeImage() { }
//______________________________________________________________________

void GtkMakeImage::run() {

  // Show URL as object name
  //progress.erase();
  //status = _("Waiting...");
  treeViewStatus = _("Waiting");
  gtk_tree_store_set(jobList()->store(), row(),
                     JobList::COLUMN_STATUS, treeViewStatus.c_str(),
                     JobList::COLUMN_OBJECT, "",
                     -1);

  mid.run();

  // By default, children of this object are visible
  GtkTreePath* path = gtk_tree_model_get_path(
      GTK_TREE_MODEL(jobList()->store()), row() );
  gtk_tree_view_expand_row(jobList()->view(), path, TRUE);
  gtk_tree_path_free(path);
}
//______________________________________________________________________

void GtkMakeImage::selectRow() {
  setNotebookPage(GUI::window.pageJigdo);
  jobList()->setWindowOwner(this);
  //updateWindow();
}
//______________________________________________________________________

bool GtkMakeImage::paused() const { return false; }
void GtkMakeImage::pause() { }
void GtkMakeImage::cont() { }
void GtkMakeImage::stop() { }

void GtkMakeImage::percentDone(uint64* cur, uint64* total) {
  *cur = 0;
  *total = 0;
}
//______________________________________________________________________

void GtkMakeImage::job_deleted() { }
void GtkMakeImage::job_succeeded() { }

void GtkMakeImage::job_failed(string* message) {
  status.swap(*message);
  //updateWindow();
  gtk_tree_store_set(jobList()->store(), row(), JobList::COLUMN_STATUS,
                     treeViewStatus.c_str(), -1);
#if DEBUG
#warning "TODO"
#endif
}

void GtkMakeImage::job_message(string* message) {
  treeViewStatus.swap(*message);
  gtk_tree_store_set(jobList()->store(), row(),
                     JobList::COLUMN_STATUS, treeViewStatus.c_str(),
                     -1);
}

Job::SingleURL::IO* GtkMakeImage::makeImageDl_new(
    Job::SingleURL* childDownload) {
# if DEBUG
  cerr << "GtkMakeImage::makeImageDl_new" << endl;
# endif
  GtkSingleURL* child = new GtkSingleURL(mid.jigdoURI(), childDownload);
  GUI::jobList.prepend(child, this); // New child of "this" is "child"
  child->run();
  // NB child may already have deleted itself at this point
  // ^^^ TRUE?!? All hell'd break loose if this happened
  return child;
}

void GtkMakeImage::makeImageDl_finished(Job::SingleURL* /*childDownload*/) { }
