/* $Id: jigdodownload.cc,v 1.2 2003/04/23 14:53:44 richard Exp $ -*- C++ -*-
  __   _
  |_) /|  Copyright (C) 2003 Richard Atterer
  | \/|  <richard at atterer.net>
   '` 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2. See
  the file COPYING for details.

  Download .jigdo file.
  JigdoDownload is a private nested class of MakeImageDl.

*/

#include <config.h>

#include <iostream>

#include <makeimagedl.hh>

using namespace Job;
//______________________________________________________________________


/* Important: Init download after io and master, because the ctor for
   download might make calls back to us! */
MakeImageDl::JigdoDownload::JigdoDownload(MakeImageDl* m,
                                          const string& jigdoURL)
    : master(m), io(0), download(this, jigdoURL) {
  io.set(master->io->makeImageDl_new(&download));
}

MakeImageDl::JigdoDownload::~JigdoDownload() { /*delete download;*/ }

void MakeImageDl::JigdoDownload::error(const string& message) {
  string e(message);
  job_failed(&e);
}
void MakeImageDl::JigdoDownload::info(const string&) {
  Assert(false); // ATM, is never called!
}

void MakeImageDl::JigdoDownload::job_deleted() {
  if (io) io->job_deleted();
}

void MakeImageDl::JigdoDownload::job_succeeded() {
  if (io) io->job_succeeded();
  master->io->makeImageDl_finished(&download);
}
void MakeImageDl::JigdoDownload::job_failed(string* message) {
  if (io) io->job_failed(message);
  master->io->makeImageDl_finished(&download);
}
void MakeImageDl::JigdoDownload::job_message(string* message) {
  if (io) io->job_message(message);
}
void MakeImageDl::JigdoDownload::singleURL_dataSize(uint64 n) {
  if (io) io->singleURL_dataSize(n);
}
void MakeImageDl::JigdoDownload::singleURL_data(const byte* data,
                                                size_t size,
                                                uint64 currentSize) {
  cerr << "jigdodownload: Got " << size << " bytes" << endl;
  if (io) io->singleURL_data(data, size, currentSize);
}
